#!/bin/bash
accumsize=$(($1))
a=$(($2))
b=$(($3))
c=$(($4))
scoredir=${5}
double=$(($accumsize*2))

declare -A SCOREMAP
SCOREMAP[12K]='64 KB'
SCOREMAP[16K]='128 KB'
SCOREMAP[21K]='256 KB'
SCOREMAP[26K]='512 KB'
SCOREMAP[32K]='1 MB'
SCOREMAP[39K]='2 MB'
SCOREMAP[47K]='4 MB'
SCOREMAP[55K]='8 MB'
SCOREMAP[64K]='16 MB'
SCOREMAP[74K]='32 MB'
SCOREMAP[75K]='32 MB'
SCOREMAP[85K]='64 MB'
SCOREMAP[97K]='128 MB'
SCOREMAP[109K]='256 MB'
SCOREMAP[123K]='512 MB'
SCOREMAP[137K]='1 GB'
SCOREMAP[152K]='2 GB'
SCOREMAP[167K]='4 GB'
SCOREMAP[184K]='8 GB'
SCOREMAP[201K]='16 GB'
SCOREMAP[219K]='32 GB'
SCOREMAP[238K]='64 GB'
SCOREMAP[258K]='128 GB'
SCOREMAP[278K]='256 GB'
SCOREMAP[299K]='512 GB'
SCOREMAP[300K]='512 GB'
SCOREMAP[320K]='1 TB'
SCOREMAP[321K]='1 TB'
SCOREMAP[322K]='1 TB'


# Compile cadidate test case
	gcc -o "${scoredir}/bitcase-xo-a${a}b${b}c${c}" "src/xoroshiro128plus-testmsbit.c" -O3 -DACCUM_SIZE=${accumsize} -DCONSTANT_A=${a} -DCONSTANT_B=${b} -DCONSTANT_C=${c}

	if [[ $? != 0 ]]; then
		echo Xoroshiro Bitcase aborted!  Compile error.
		echo
		exit
	fi

# Run and score the candidate
	"${scoredir}/bitcase-xo-a${a}b${b}c${c}" | stdbuf -o L "./PractRand" stdin -a -multithreaded -tlmin 1KB >"${scoredir}/PRscore-xo-s${accumsize}bit-a${a}b${b}c${c}.out"

	if [[ $? != 0 ]]; then
		echo Xoroshiro Bitcase aborted!  Test error.
		echo
		exit
	fi

	rm "${scoredir}/bitcase-xo-a${a}b${b}c${c}"

# Output the score
	scoresize=$(ls -lh "${scoredir}/PRscore-xo-s${accumsize}bit-a${a}b${b}c${c}.out" | awk -F'[,/ \t]*' '{print $5}')
	printf "Bit truncated candidate size ${accumsize} [${a} ${b} ${c}] - PractRand score: ${SCOREMAP[${scoresize}]}\n"
