#include <limits.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>


//#define  ACCUM_SIZE  16   // Passed in as -D gcc parameter. (Min=8+WORD_POSITION, Max=64) Bit width of generated random numbers.
//#define  WORD_POSITION  1   // Passed in as -D gcc parameter.
//#define  CONSTANT_A  11   // Passed in as -D gcc parameter.
//#define  CONSTANT_B  2   // Passed in as -D gcc parameter.
//#define  CONSTANT_C  6   // Passed in as -D gcc parameter.

#define  ACCUM_MASK  (((1ULL<<(ACCUM_SIZE-1))-1)<<1|1)   // Bit of a shuffle to work on all 64 bits :)


// Seed the state array.
static uint64_t  s[2] = {1, 0};


static uint64_t next(void) {
	uint64_t s1 = s[0];
	uint64_t s0 = s[1];
	uint64_t result = (s0 + s1) & ACCUM_MASK;

	s1 = (s1 ^ (s1 << CONSTANT_A)) & ACCUM_MASK;
	s[0] = s0;
	s[1] = s1 ^ s0 ^ (s1 >> CONSTANT_B) ^ (s0 >> CONSTANT_C);

	return result; 
}


//  Store as Little-Endian byte ordering.
int  main(int argc, char* argv[])
{
	uint64_t  random64;
	int  chunk = 0, i;
	uint8_t  k = 0;


	// Print some randomness
	while(1)
	{
		random64 = next() >> WORD_POSITION;   // Remove lsb because not quite so random.
//		printf( "%016lx ", random64 );

		if( chunk ) {  // Any remainder?
			k |= (random64 << chunk) & 0xff;   // Concatenate to full byte.
			chunk = 8 - chunk;   // Concatenating size.
			putchar( k );
//			printf( "%02x ", k );
		}

		while(chunk <= ((ACCUM_SIZE-WORD_POSITION) - 8)) {   //  Stop at last full byte. (Bit group increments from base bit)
			k = random64 >> chunk;   // One byte.
			chunk += 8;
			putchar( k );
//			printf( "%02x ", k );
		}
//		printf("\n");

		k = random64 >> chunk;   // Any remainder.
		chunk = (ACCUM_SIZE-WORD_POSITION) - chunk;  //  Remainder size.
//		printf( "%02x %04d ", k, chunk );
	}

	return 0;
}
